precision mediump float;
precision mediump int;

uniform float kernel[900];
uniform int kernelSize;
uniform sampler2D iChannel0;
uniform vec3 iResolution;
varying vec2 uv;

uniform vec4 overlay;


void main()
{

    vec4 color = vec4(0.0);
    int halfSize = kernelSize / 2;

    int index = 0;
    for(int y=-halfSize;y<=halfSize;y++)
    {
        for(int x = -halfSize;x<=halfSize;x++)
        {
            color += texture2D(iChannel0,uv + vec2(x,y)/iResolution.xy) * kernel[index];
            index++;
        }
    }
    gl_FragColor = vec4(overlay.a*overlay.rgb + (1.-overlay.a) * color.rgb,1.0);
}
