// Modified from https://www.shadertoy.com/view/lsdGDH

precision highp float;

varying vec2 uv;
uniform sampler2D iChannel0;
uniform sampler2D iChannel1;
uniform float iTime;
uniform bool showWave;

vec4 getFreq(float f) {
    float fft  = texture2D(iChannel0, vec2(f, 0.5)).x;
    vec3 col = vec3(fft, 4.0 * fft * (1.0 - fft), 1.0 - fft) * fft;
    return max(vec4(col, 1.0), 0.);
}
    #define t iTime * 6.
    #define v 1.
    #define fov 90.
    #define PI 3.1415

void main() {
    vec2 fragCoord =uv - .5;
    vec2 muv = fragCoord;

    vec4 c = texture2D(iChannel1, uv);

    if (showWave){
        float volM = getFreq(.9).r * v;
        float volL = getFreq(.25).r * v;
        for (float i = 8.; i > 0.; i--) {

            muv = fragCoord * tan (radians (i * 4. + fov)/2.0);

            muv.y += sin(t + volL + muv.x * 43.) * volM / 2.;
            muv.y += sin(2.3 * t + PI + 2. + muv.x * 127.) * volM / 4.;
            muv.y += sin(PI + 3. + muv.x * 32. + t * 3.12) * volL / 4.;

            if (muv.y < 0.005 && muv.y > -0.005) {
                c += max(
                vec4(1. - i * .15) * (1. - abs(muv.y) * 200.),
                .0
                );
            }
        }
    }

    gl_FragColor = c;
}